/* -*- tab-width:4;c-file-style:"cc-mode"; -*- */
/*
 * ff2dirac_dirac.h -- Utilities common to dirac-research and Schroedinger
 * Copyright (C) 2010 BBC, Anuradha Suraparaju <asuraparaju@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with This program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _F2D_DIRAC_H_
#define _F2D_DIRAC_H_

#ifdef F2D_ARRAY_SIZE
#undef F2D_ARRAY_SIZE
#endif
#define F2D_ARRAY_SIZE(x) (sizeof(x)/sizeof(x[0]))

typedef struct {
    void *ctx;
    int eos_signalled;
    int eos_pulled;
    ogg_int64_t decode_frame_number;
    ogg_int64_t presentation_frame_number;
    int distance_from_sync;
    ogg_int64_t packet_no;
    unsigned char *dirac_buf;
    int dirac_buf_size;
    unsigned char *dirac_frame_buf;
    int dirac_frame_size;
    int fps_num;
    int fps_denom;
    int is_sync_point;
    int is_not_first_seqhdr;
    int preset;
    int ff_pix_fmt;
} ff2dirac_privdata_t;

extern int ff2dirac_get_video_format_idx(ff2dirac ctx);

extern int ff2dirac_get_wavelet_idx(char *wavelet);

extern int ff2dirac_get_mv_precision_idx(char *mv_prec);

extern void ff2dirac_calculate_granulepos (ff2dirac_privdata_t *dd, ogg_packet *op);

extern double ff2dirac_granule_time(ff2dirac_video_enc_state_t *dd, ogg_int64_t granulepos);

extern int ff2dirac_granule_shift(ff2dirac_video_enc_state_t *dd);

extern ogg_int64_t ff2dirac_get_duration(ff2dirac_video_enc_state_t *dd);

extern int ff2dirac_packet_iskeyframe(ogg_packet *op);
#endif
