/* -*- tab-width:4;c-file-style:"cc-mode"; -*- */
/*
 * libschroedinger_options.h -- Utilities header to process Schroedinger's encoder options dynamically
 * Copyright (C) 2010 BBC, Anuradha Suraparaju <asuraparaju@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with This program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef LIBSCHROEDINGER_OPTIONS_H
#define LIBSCHROEDINGER_OPTIONS_H

#include <getopt.h>

typedef struct LibSchroOptValuePair {
    int idx;
    char *value;
} LibSchroOptValuePair;

extern int libschroedinger_add_encoding_options(struct option **optlist, int numopts, int * const flagptr, int flagval);

extern void libschroedinger_print_usage(void);

extern int libschroedinger_set_encoder_option(int optidx, const char *value);

extern const LibSchroOptValuePair* const libschroedinger_get_encoder_options(void);

extern void libschroedinger_clear_options(void);

#endif /*LIBSCHROEDINGER_OPTIONS_H*/
